From 0dee4b4278a4b9f9735cffb6b4cb6ec3fdf9c225 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 10 2020 06:50:55 +0000
Subject: [PATCH 1678/2232] Merge pull request #555 from dtolnay/impl


Limit instantiation of Vec and Box shims to local element type
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index c5063a2..9e4bd6b 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -961,6 +961,8 @@ fn expand_rust_box(ident: &RustName, types: &Types) -> TokenStream {
     let span = ident.span();
     quote_spanned! {span=>
         #[doc(hidden)]
+        unsafe impl ::cxx::private::ImplBox for #ident {}
+        #[doc(hidden)]
         #[export_name = #link_uninit]
         unsafe extern "C" fn #local_uninit(
             this: *mut ::std::boxed::Box<::std::mem::MaybeUninit<#ident>>,
@@ -1000,6 +1002,8 @@ fn expand_rust_vec(elem: &RustName, types: &Types) -> TokenStream {
     let span = elem.span();
     quote_spanned! {span=>
         #[doc(hidden)]
+        unsafe impl ::cxx::private::ImplVec for #elem {}
+        #[doc(hidden)]
         #[export_name = #link_new]
         unsafe extern "C" fn #local_new(this: *mut ::cxx::private::RustVec<#elem>) {
             ::std::ptr::write(this, ::cxx::private::RustVec::new());
diff --git a/src/lib.rs b/src/lib.rs
index 1f24ca2..1e3b212 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -448,7 +448,7 @@ pub mod private {
     pub use crate::rust_slice::RustSlice;
     pub use crate::rust_str::RustStr;
     pub use crate::rust_string::RustString;
-    pub use crate::rust_type::RustType;
+    pub use crate::rust_type::{ImplBox, ImplVec, RustType};
     pub use crate::rust_vec::RustVec;
     pub use crate::shared_ptr::SharedPtrTarget;
     pub use crate::unique_ptr::UniquePtrTarget;
diff --git a/src/rust_type.rs b/src/rust_type.rs
index 2f4f089..7bcf440 100644
--- a/src/rust_type.rs
+++ b/src/rust_type.rs
@@ -1 +1,3 @@
 pub unsafe trait RustType {}
+pub unsafe trait ImplBox {}
+pub unsafe trait ImplVec {}

